<?php
function is_idc_key_valid($data) {
	$valid = 0;
	if (isset($data['response'])) {
		if ($data['response']) {
			if (isset($data['download'])) {
				if ($data['download'] == '29') {
					$valid = 1;
				}
			}
		}
	}
	return $valid;
}

function idf_idc_license_type($valid) {
	switch ($valid) {
		case 1:
			return 2;
			break;

		default:
			return 0;
			break;
	}
}

function idf_idc_validate_key($key) {
	$id_account = get_option('id_account');
	$download_list = array(
		'30' => '83885', //Enterprise Annual
		'29' => '83887', //Echelon Annual
		'1' => '1'
	);

	$curl_success = true;
	$api_url = 'https://members.ignitiondeck.com/';
	$query = array(
		'edd_action' => 'verify_license',
		'url' => $_SERVER['HTTP_HOST'],
		'license' => $key
	);
	$querystring = http_build_query($query);
	$url = urldecode($api_url.'?'.$querystring);

	$ch = curl_init($url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
    curl_setopt($ch, CURLOPT_REFERER, home_url());
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    $response = curl_exec($ch);
	$response_array = array('valid' => false, 'download' => null);
    if (!$response) {
    	// curl failed https, lets try http
    	curl_close($ch);
    	$api_url = 'http://members.ignitiondeck.com/';
    	$url = urldecode($api_url.'?'.$querystring);
    	$ch = curl_init($url);
    	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    	curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
    	curl_setopt($ch, CURLOPT_REFERER, home_url());
    	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$response = curl_exec($ch);
    	if (!$response) {
    		// final curl fail
    		echo 'Curl error: '.curl_error($ch);
    		$curl_success = false;
    	}
    }
	curl_close($ch);
	$return = json_decode($response,true);
	if( $curl_success && ($return['success']==false && $return['error']=='missing' && $return['license']=='invalid') ) {
		//If license missing on EDD check Legacy
		$id_account = get_option('id_account');
		$api_url = 'https://ignitiondeck.com/id/';
		$query = array(
			'action' => 'md_validate_license',
			'key' => $key,
			'id_account' => $id_account
		);
		$querystring = http_build_query($query);
		$url = $api_url.'?'.$querystring;

		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
		curl_setopt($ch, CURLOPT_REFERER, home_url());
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$response = curl_exec($ch);
		$response_array = array('valid' => false, 'download' => null);
		if (!$response) {
			// curl failed https, lets try http
			curl_close($ch);
			$api_url = 'http://ignitiondeck.com/id/';
			$url = $api_url.'?'.$querystring;
			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
			curl_setopt($ch, CURLOPT_REFERER, home_url());
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			$response = curl_exec($ch);
			if (!$response) {
				// final curl fail
				echo 'Curl error: '.curl_error($ch);
			}
			else {
				$response_array = idf_process_validation($response);
			}
		}
		else {
			$response_array = idf_process_validation($response);
		}
		curl_close($ch);
		return $response_array['download'];
		//If license missing on EDD check Legacy
	} elseif( $curl_success && ($return['success']==1 && $return['license']=='valid') ){
		$return = apply_filters( 'edd_product_ids', $return );
		update_option('license_expiry', $return['expires']);
		echo edd_api_notice('valid');
		return array_search($return['item_id'], $download_list);
    } else {
        if(isset($return['error'])) {
			echo edd_api_notice($return['error'], 'error');
		}
    }
}

add_action('idc_license_update', 'idc_license_update');

function idc_license_update($idc_license_key) {
	$valid = 0;
	$general = get_option('md_receipt_settings');
	$general = maybe_unserialize($general);
	$general['license_key'] = $idc_license_key;
	update_option('md_receipt_settings', $general);
	$validate = idf_idc_validate_key($idc_license_key);

	//if( is_bool($validate) && !$validate ) return;

	switch ($validate) {
		case '30':
			$is_pro = 1;
			$is_idc_licensed = 1;
			$is_basic = 0;
			break;
		case '29':
			$is_idc_licensed = $is_basic = 1;
			$is_pro = 0;
			break;
		default:
			$is_pro = $is_idc_licensed = $is_basic = 0;
			break;
	}
	#devnote we can set transients from the option? Can we push these to idcf/idc php?
	update_option('idcf_updated', true);
	
	update_option('is_id_pro', $is_pro);
	update_option('is_idc_licensed', $is_idc_licensed);
	update_option('is_id_basic', $is_basic);
	set_transient('is_id_pro', $is_pro);
	set_transient('is_idc_licensed', $is_idc_licensed);
	set_transient('is_id_basic', $is_basic);
}

add_action('schedule_twicedaily_idf_cron', 'idf_schedule_twicedaily_idc_cron');

function idf_schedule_twicedaily_idc_cron() {
	$license_option = get_option('idf_license_entry_options');
	if (empty($license_option) || $license_option == 'keys') {
		$general = get_option('md_receipt_settings');
		$general = maybe_unserialize($general);
		$idc_license_key = (isset($general['license_key']) ? $general['license_key'] : '');
		idc_license_update($idc_license_key);
	}
}
?>
