<?php
add_action('idf_id_update_account', 'idf_id_update_account');

function idf_id_set_validation_type($type = 'email') {
	update_option('idf_license_entry_options', $type);
}

function idf_id_update_account($id_account) {
	update_option('id_account', $id_account);
	$license_level = idf_id_validate_account($id_account);
	//if( !$license_level ) return;

	switch ($license_level) {
		case 'ide':
			$is_pro = 1;
			$is_idc_licensed = 1;
			$is_basic = 0;
			break;
		case 'idc':
			$is_idc_licensed = $is_basic = 1;
			$is_pro = 0;
			break;
		default:
			$is_pro = $is_idc_licensed = $is_basic = 0;
			break;
	}
	#devnote we can set transients from the option? Can we push these to idcf/idc php?
	update_option('is_id_pro', $is_pro);
	update_option('is_idc_licensed', $is_idc_licensed);
	update_option('is_id_basic', $is_basic);
	set_transient('is_id_pro', $is_pro);
	set_transient('is_idc_licensed', $is_idc_licensed);
	set_transient('is_id_basic', $is_basic);
}

function idf_id_validate_account($id_account) {
	$download_list = array(
		'ide' => '83885', //Enterprise Annual
		'idc' => '83887', //Echelon Annual
		'free' => '1'
	);
	//Activate License
	$curl_success = true;
	$api_url = 'https://members.ignitiondeck.com/';
	$query = array(
		'edd_action' => 'verify_license_by_email',
		'url' => $_SERVER['HTTP_HOST'],
		'email' => $id_account
	);
	$querystring = http_build_query($query);
	$url = urldecode($api_url.'?'.$querystring);

	$ch = curl_init($url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
    curl_setopt($ch, CURLOPT_REFERER, home_url());
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    $response = curl_exec($ch);
	if (!$response) {
    	// curl failed https, lets try http
    	curl_close($ch);
    	$api_url = 'http://members.ignitiondeck.com/';
    	$url = urldecode($api_url.'?'.$querystring);
    	$ch = curl_init($url);
    	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    	curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
    	curl_setopt($ch, CURLOPT_REFERER, home_url());
    	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$response = curl_exec($ch);
    	if (!$response) {
    		// final curl fail
    		echo 'Curl error: '.curl_error($ch);
    		$curl_success = false;
    	}
    }
    curl_close($ch);
	$return = json_decode($response,true);
	if( $curl_success && ($return['success']==false && $return['error']=='missing' && $return['license']=='invalid') ) {
		//If license missing on EDD check Legacy
		$download_list = array(
			'ide' => '30',
			'idc' => '29',
			'free' => '1'
		);
		$api_url = 'https://ignitiondeck.com/id/';
		$query = array(
			'action' => 'md_validate_account',
			'id_account' => $id_account,
			'download_list' => $download_list
		);
		$querystring = http_build_query($query);
		$url = $api_url.'?'.$querystring;
	
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
		curl_setopt($ch, CURLOPT_REFERER, home_url());
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$response = curl_exec($ch);
		if (!$response) {
			// curl failed https, lets try http
			curl_close($ch);
			$api_url = 'http://ignitiondeck.com/id/';
			$url = $api_url.'?'.$querystring;
			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
			curl_setopt($ch, CURLOPT_REFERER, home_url());
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			$response = curl_exec($ch);
			if (!$response) {
				// final curl fail
				echo 'Curl error: '.curl_error($ch);
			}
		}
		curl_close($ch);
		$license_level = idf_process_account_validation($response);
		return array_search($license_level, $download_list);
		//If license missing on EDD check Legacy
	} elseif( $curl_success && ($return['success']==1 && $return['license']=='valid') ){
		$return = apply_filters( 'edd_product_ids', $return );
		update_option('license_expiry', $return['expires']);
		echo edd_api_notice('valid');
		return array_search($return['item_id'], $download_list);
    } else {
        if(isset($return['error'])) {
			echo edd_api_notice($return['error'], 'error');
		}
    }
}

function idf_schedule_twicedaily_id_account_cron() {
	$id_account = get_option('id_account');
	$license_option = get_option('idf_license_entry_options');
	if ($license_option == 'email') {
		idf_id_update_account($id_account);
	}
}

add_action('schedule_twicedaily_idf_cron', 'idf_schedule_twicedaily_id_account_cron');

function idf_parse_license($key_data) {
	$scale = max($key_data['types']);
	$return = 0;
	switch ($scale) {
		case '1':
			$return = update_option('idf_key', $key_data['keys']['idcf_key']);
			break;
		case '2':
			$return = update_option('idf_key', $key_data['keys']['idc_key']);
			break;
		case '3':
			$return = update_option('idf_key', $key_data['keys']['idcf_key']);
		default:
			$return = update_option('idf_key', '');
			break;
	}
	return $return;
}


function edd_api_notice($ret, $class='success') {
	$msg = '';
	switch($ret) {
		case 'missing' : $msg = 'License doesn\'t exist'; break;
		case 'missing_url' : $msg = 'URL not provided'; break;
		case 'license_not_activable' : $msg = 'Attempting to activate a bundle\'s parent license'; break;
		case 'disabled' : $msg = 'License key revoked'; break;
		case 'no_activations_left' : $msg = 'No activations left'; break;
		case 'expired' : $msg = 'License has expired, <a href="https://members.ignitiondeck.com/welcome/" target="_blank">renew it now</a>'; break;
		case 'key_mismatch' : $msg = 'License is not valid for this product'; break;
		case 'invalid_item_id' : $msg = 'Invalid Item ID'; break;
		case 'item_name_mismatch' : $msg = 'License is not valid for this product'; break;
		case 'blank' : $msg = 'Please enter a valid license key'; break;
		case 'valid' : $msg = 'License has been validated successfully'; break;
	}
	$message = __( $msg, 'ignitiondeck' );
	$notice = '<div class="notice notice-'.$class.' is-dismissible"><p>'.$message.'.</p></div>';
	return $notice;
}

add_filter( 'edd_product_ids', 'process_edd_product_ids' );
function process_edd_product_ids( $return ) {
	if(isset($return['item_id'])) {
		switch($return['item_id']) {
			case 84018: //Enterprise Lifetime
				$return['item_id'] = 83885;
				break;
			default:
				break;
		}
	}
    return $return;
}
?>
