jQuery(document).ready(function() {
    jQuery('body').on('click','.wizard-tab li a',function(e) {
        e.preventDefault();
        //window.location.hash = jQuery(this).attr('href');
        idWizardScreen(jQuery(this).attr('href'));
    });
    checkHash();

    jQuery('.register-email').keyup(function() {
        jQuery(this).removeClass('registered');
        jQuery('#wiz-register .wiz-button').prop('disabled',false);
        jQuery('#wiz-register .wiz-button').html('Register');
    });
});
function idWizardScreen(id='#wiz-register') {
    history.pushState({}, "", id);
    jQuery('html,body').animate({
        scrollTop: jQuery(id).position().top -= 100
    });
    jQuery('.wizard-tab li').removeClass('active');
    jQuery('.wizard-tab li a[href="'+id+'"]').parent().addClass('active');

    jQuery('.wizard-tabs .wizard-tab-content').removeClass('active');
    jQuery(id).addClass('active');
    if(id=='#wiz-install') {
        checkInstallConditions();
    }
}

function checkHash() {
    if(window.location.hash != '') {
        idWizardScreen(window.location.hash);
    }
}

function checkInstallConditions() {
    jQuery('#wiz-install ul li').each(function() {
        if(jQuery(this).data('status')!='active') {
            jQuery('#wiz-install .wiz-button.install').prop('disabled',false);
            jQuery('#wiz-install .wiz-button.continue').prop('disabled',true);
        }
    })
}

function wizard_action(action,ele=null) {
    switch(action) {
        case 'register_email':
            jQuery('#wiz-register .wiz-button').prop('disabled',true);
            jQuery('#wiz-register .wiz-button').html('Registering<em></em>');
            var data = {
                action: 'idf_wizard_register',
                email: jQuery('.register-email').val(),
            };
            jQuery.post( idf_ajaxurl, data, function(response) {
                var r = jQuery.parseJSON(response);
                console.log('Registration Response:',response);
                if(r.error==true) {
                    alert(r.message);
                } else if(r.status=='subscribed') {
                    alert('Registered successfully.');
                    idWizardScreen('#wiz-install');
                } else {
                    alert(jQuery('.register-email').val()+' is already a list member.');
                    idWizardScreen('#wiz-install');
                }
                jQuery('.register-email').addClass('registered');
                jQuery('#wiz-register .wiz-button').html('Registered');
            });
            break;
        case 'plugin_install':
            var plugins = new Array();
            jQuery('#wiz-install .wiz-button.install').prop('disabled',true);
            var i=0;
            jQuery('#wiz-install ul li').each(function() {
                if(jQuery(this).data('status')!='active') {
                    plugins.push(i);
                }
                i++;
            });
            i=0;
            plugin_install(i, plugins);
            break;
        case 'verify_license':
            jQuery(ele).html('Validating<em></em>');
            var data = {
                action: 'idf_wizard_verify_license',
                license: jQuery(ele).parent().find('.wiz-control-inline').val(),
            };
            jQuery.post( idf_ajaxurl, data, function(response) {
                jQuery.post( idf_ajaxurl, data, function(response) {
                    var content = jQuery(response).filter("#license-details");
                    var filtered = content.contents();
                    jQuery('#license-details').html(filtered);
    
                    var content = jQuery(response).filter("#configure-details");
                    var filtered = content.contents();
                    jQuery('#configure-details').html(filtered);
                    //jQuery(ele).html('Activated');
                    jQuery('#wiz-upgrade .button-group .wiz-button').removeClass('hidden');
                });
            });
            break;
        case 'save_payment':
            jQuery(ele).html('Saving<em></em>');
            var data = {
                action: 'idf_wizard_save_payment',
                payment: jQuery('.payment-platform input:checked').val(),
            };
            jQuery.post( idf_ajaxurl, data, function(response) {
                var content = jQuery(response).filter("#license-details");
                var filtered = content.contents();
                jQuery('#license-details').html(filtered);
                
                var content = jQuery(response).filter("#configure-details");
                var filtered = content.contents();
                jQuery('#configure-details').html(filtered);
                //jQuery(ele).html('Save');
                //jQuery('#wiz-upgrade .button-group .wiz-button').removeClass('hidden');
            });
            break;
        case 'theme_install':
            if(jQuery(ele).hasClass('locked')) {
                window.open(jQuery(ele).data('url'), '_blank').focus();
            } else {
                jQuery(ele).html('Installing<em></em>');
                var data = {
                    action: 'idf_wizard_install_themes',
                    url: jQuery(ele).data('url'),
                    slug: jQuery(ele).data('slug'),
                };
                jQuery.post( idf_ajaxurl, data, function(response) {
                    jQuery(ele).html(response);
                    alert('Theme is installed. Visit Appearance > Themes to activate.');
                });
            }
            break;
        default:
            break;
    }
}

function wizard_call(data) {
    jQuery.post( idf_ajaxurl, data, function(response) {
        if( data.action=='idf_wizard_install_plugins' ) {
            jQuery('.wizard-tabs .active ul').html( response );
        }
        jQuery('.wizard-tab-content').removeClass('wiz-loader');
    });
}

function plugin_install(i, plugins) {
    if( i >= jQuery('#wiz-install ul li').length ) {
        jQuery('#wiz-loader').fadeIn();
        let pageUrl = window.location.href;
        jQuery.get( pageUrl, {}, function(response) {
            var content = jQuery(response).filter("#wpwrap");
            var filtered = content.contents();
            jQuery('#wpwrap').html(filtered);

            jQuery('#wiz-install .wiz-button.install').html('Installed and Activated');
            jQuery('#wiz-install .wiz-button.continue').prop('disabled',false);
            checkHash();
            jQuery('#wiz-loader').fadeOut();
        });
    } else {
        var ele = jQuery('#wiz-install ul li:eq('+i+')');
        if(ele.data('status') == 'not') {
            ele.find('span').html('Installing<em></em>');
            var data = {
                action: 'idf_wizard_install_plugins',
                name: ele.data('name'),
                slug: ele.data('slug'),
                url: ele.data('url'),
            };
            jQuery.post( idf_ajaxurl, data, function(response) {
                ele.find('span').html('Activating<em></em>');
                var data = {
                    action: 'idf_wizard_activate_plugins',
                    name: ele.data('name'),
                    slug: ele.data('slug'),
                    url: ele.data('url'),
                };
                jQuery.post( idf_ajaxurl, data, function(response) {
                    ele.find('span').html('Installed and Activated');
                    i++;
                    plugin_install(i, plugins);
                });
            });
        } else if(ele.data('status') == 'installed') {
            ele.find('span').html('Activating<em></em>');
            var data = {
                action: 'idf_wizard_activate_plugins',
                name: ele.data('name'),
                slug: ele.data('slug'),
                url: ele.data('url'),
            };
            jQuery.post( idf_ajaxurl, data, function(response) {
                ele.find('span').html('Installed and Activated');
                i++;
                plugin_install(i, plugins);
            });
        } else {
            i++;
            plugin_install(i, plugins);
        }
    }
}
let x = 0;
let elipsis = '';
setInterval(function () {
    x++;
    if(x>3) x = 1;
    elipsis = '';
    for(y=0;y<x;y++) {
        elipsis += '.';
    }
    jQuery('.wizard-tabs em, #wiz-loader em').each(function() {
        jQuery(this).html(elipsis);
    });
}, 500);
