<h2>Choose Your Theme</h2>
<p>The Free Edition of IgnitionDeck depends on one of the unlocked themes below.</p>
<div id="configure-details" class="configure-details">
    <div class="themes-list">
        <?php
        $all_themes = wp_get_themes();
        $current_theme = wp_get_theme();
        //echo '<pre>'; print_r($all_themes); exit;
        $themes = array();
        $themes[] = array (
            'name'  =>  '500 Framework',
            'slug'  =>  'fivehundred',
            'description'  =>  'Its a crowdfunding theme framework created for use with the IgnitionDeck plugin.',
            'image'  =>  '',
            'demo'  =>  'https://theme500.com/framework/',
            'doc'  =>  'https://docs.ignitiondeck.com/article/37-500-framework',
            'url'  =>  'http://files.ignitiondeck.com/fh_latest.zip',
            'locked'  =>  false,
            'required-500'  =>  false,
        );

        $themes[] = array (
            'name'  =>  '500 Settlement',
            'slug'  =>  'fivehundred-settlement',
            'description'  =>  'Settlement is here to build your non-profit website from start to finish, easing the creation and management of fundraising and crowdfunding projects for your charity.',
            'image'  =>  plugins_url( '/ignitiondeck/images/fivehundred-settlement.png' ),
            'demo'  =>  'https://theme500.com/settlement/',
            'doc'  =>  'https://docs.ignitiondeck.com/article/40-settlement',
            //'url'  =>  'https://www.ignitiondeck.com/crowdfunding/product/settlement-theme/',
            'url'  =>  'https://members.ignitiondeck.com/my-account/view-licenses/',
            'locked'  =>  true,
            'required-500'  =>  true,
        );

        $themes[] = array (
            'name'  =>  '500 Stellar',
            'slug'  =>  'fivehundred-stellar',
            'description'  =>  'The Stellar IgnitionDeck Platform Theme is for serious individuals, not-for-profit organizations and businesses, who aim to develop large-scale crowdfunding or fundraising platform.',
            'image'  =>  plugins_url( '/ignitiondeck/images/fivehundred-stellar.png' ),
            'demo'  =>  'https://theme500.com/stellar',
            'doc'  =>  'https://docs.ignitiondeck.com/article/39-stellar',
            //'url'  =>  'https://www.ignitiondeck.com/crowdfunding/product/stellar-theme/',
            'url'  =>  'https://members.ignitiondeck.com/my-account/view-licenses/',
            'locked'  =>  true,
            'required-500'  =>  true,
        );
        
        $themes[] = array (
            'name'  =>  'Multifondo',
            'slug'  =>  'multifondo',
            'description'  =>  'Multifondo is a fully responsive and mobile-read fundraising theme for WordPress.',
            'image'  =>  plugins_url( '/ignitiondeck/images/multifondo.png' ),
            'demo'  =>  'https://theme500.com/multifondo/',
            'doc'  =>  'https://docs.ignitiondeck.com/article/43-multifondo',
            //'url'  =>  'https://www.ignitiondeck.com/crowdfunding/product/multifondo-theme/',
            'url'  =>  'https://members.ignitiondeck.com/my-account/view-licenses/',
            'locked'  =>  true,
            'required-500'  =>  false,
        );
        
        $themes[] = array (
            'name'  =>  'Fundify',
            'slug'  =>  'fundify',
            'description'  =>  'Fundify is a WordPress theme and relies on the crowdfunding functionality built into the IgnitionDeck plugins.',
            'image'  =>  plugins_url( '/ignitiondeck/images/fundify.png' ),
            'demo'  =>  'https://theme500.com/fundify/',
            'doc'  =>  'https://docs.ignitiondeck.com/article/41-fundify',
            //'url'  =>  'https://www.ignitiondeck.com/crowdfunding/product/fundify-theme/',
            'url'  =>  'https://members.ignitiondeck.com/my-account/view-licenses/',
            'locked'  =>  true,
            'required-500'  =>  false,
        );
        
        foreach($themes as $theme) {
            $disabled = '';
            if(get_option('is_idc_licensed')) {
                $theme['locked'] = false;
                $status = 'Download from IgnitionDeck';
            } else {
                $status = $theme['locked']?'Upgrade to Unlock':'Download from IgnitionDeck';
            }
            if($current_theme->name == $theme['name']) {
                $disabled = 'disabled="disabled"';
                $status = 'Installed and Activated';
            } elseif(!empty( $all_themes[$theme['slug']] )) {
                $status = 'Activate';
                $theme['url'] = admin_url('themes.php?theme='.$theme['slug']);
            }
            ?>
            <div class="id-theme">
                <div class="theme-image <?php echo $theme['locked']?'locked':''; ?>">
                    <?php echo $theme['image']?'<img src="'.$theme['image'].'">':''; ?>
                </div>
                <div class="theme-details">
                    <p><strong><?php echo $theme['name']; ?></strong> - <?php echo $theme['description']; ?></p>
                    <ul>
                        <li><a href="<?php echo $theme['demo']; ?>" target="_blank">View Demo</a></li>
                        <li><a href="<?php echo $theme['doc']; ?>" target="_blank">Read Documentation</a></li>
                        <?php
                        if($theme['required-500']) {
                            echo '<li><b>Requirement: 500 Framework parent theme</b></li>';
                        } else {
                            echo '<li style="list-style:none"><br></li>';
                        }
                        ?>
                    </ul>
                    <?php
                    if($theme['locked'] || $theme['slug']=='fivehundred') {
                        ?>
                        <p><button data-slug="<?php echo $theme['slug']; ?>" data-url="<?php echo $theme['url']; ?>" type="button" class="wiz-button <?php echo $theme['locked']?'locked':''; ?>" onclick="wizard_action('theme_install',this)" <?=$disabled?>><?php echo $status; ?></button></p>
                        <?php
                    } else {
                        ?>
                        <p><a href="<?php echo $theme['url']; ?>" class="wiz-button" <?php echo $status=='Activate'?'':'target="_blank"';?>><?php echo $status; ?></a></p>
                        <?php
                    }
                    ?>
                </div>
            </div>
            <?php 
        }
        ?>
    </div>
    <div class="clearfix"></div>
    <p class="text-center">
        <button type="button" class="wiz-button" onclick="idWizardScreen('#wiz-connect')">Continue</button>
    </p>
</div>
